Index: src/xplcommon/BufferedStream.h
===================================================================
--- src/xplcommon/BufferedStream.h	(revision 17)
+++ src/xplcommon/BufferedStream.h	(revision 21)
@@ -58,5 +58,5 @@
 public:
     /**
-     * Destroy the buffered waitable.
+     * Destroy the buffered stream.
      */
     virtual ~BufferedStream();
@@ -64,5 +64,5 @@
     /**
      * Get the reference of the reading buffer. Note, that it can be a
-     * 0 reference, if the waitable has no reading buffer.
+     * 0 reference, if the stream has no reading buffer.
      */
     ReadingBuffer& getReadingBuffer();
@@ -70,5 +70,5 @@
     /**
      * Get the reference of the writing buffer. Note, that it can be a
-     * 0 reference, if the waitable has no writing buffer.
+     * 0 reference, if the stream has no writing buffer.
      */
     WritingBuffer& getWritingBuffer();
Index: src/xplcommon/LocalAcceptor.h
===================================================================
--- src/xplcommon/LocalAcceptor.h	(revision 17)
+++ src/xplcommon/LocalAcceptor.h	(revision 21)
@@ -32,5 +32,5 @@
 //------------------------------------------------------------------------------
 
-#include "Acceptor.h"
+#include "Failable.h"
 
 //------------------------------------------------------------------------------
@@ -48,11 +48,28 @@
  * connection.
  */
-class LocalAcceptor : public Acceptor
+class LocalAcceptor : public FailableReference<LocalAcceptor>
 {
 public:
+
+    /**
+     * Start accepting a connection.
+     *
+     * If a connection is already accepted, but not retrieved yet, it
+     * returns true.
+     *
+     * If a new socket becomes immediately available, it returns true.
+     *
+     * If some error occurs, the acceptor is marked as failed.
+     */
+    bool accept();
+
     /**
      * Get the local socket accepted last. If no socket was accepted,
-     * return 0. The local socket's waiter will be the given one
-     * (which can be 0).
+     * return 0. The local socket's waiter will be the given one. If
+     * the server socket has no waiter, this one should be 0. If the
+     * server socket has a waiter, this one should not be 0. In other
+     * words, if the server socket is non-blocking, the accepted one
+     * should also be non-blocking, if the server socket is blocking,
+     * the accepted one should also be blocking.
      */
     LocalSocket* getSocket(Waiter* waiter,
Index: src/xplcommon/LocalClientSocket.h
===================================================================
--- src/xplcommon/LocalClientSocket.h	(revision 17)
+++ src/xplcommon/LocalClientSocket.h	(revision 21)
@@ -32,5 +32,5 @@
 //------------------------------------------------------------------------------
 
-#include "ClientSocket.h"
+#include "BufferedStream.h"
 
 //------------------------------------------------------------------------------
@@ -44,4 +44,8 @@
 //------------------------------------------------------------------------------
 
+class LocalConnector;
+
+//------------------------------------------------------------------------------
+
 /**
  * Client socket that connects to a server socket locally. On Linux it
@@ -50,5 +54,5 @@
  * The server socket's name should be given.
  */
-class LocalClientSocket : public ClientSocket
+class LocalClientSocket : public BufferedStream
 {
 public:
@@ -65,4 +69,9 @@
                       size_t readingCapacity = DEFAULT_CAPACITY,
                       size_t writingCapacity = DEFAULT_CAPACITY);
+
+    /**
+     * Get the connector. Use this object to connect to another socket.
+     */
+    LocalConnector& getConnector();
 };
 
Index: src/xplcommon/LocalConnector.h
===================================================================
--- src/xplcommon/LocalConnector.h	(revision 21)
+++ src/xplcommon/LocalConnector.h	(revision 21)
@@ -0,0 +1,112 @@
+// Copyright (c) 2012 by István Váradi
+
+// This file is part of libxplcommon, a common utility library for
+// development related to X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+#ifndef XPLCOMMON_LOCALCONNECTOR_H
+#define XPLCOMMON_LOCALCONNECTOR_H
+//------------------------------------------------------------------------------
+
+#include "Failable.h"
+
+//------------------------------------------------------------------------------
+
+#if 0 // The public interface of a connector for a local client socket
+
+//------------------------------------------------------------------------------
+
+namespace xplcommon {
+
+//------------------------------------------------------------------------------
+
+/**
+ * Class representing the creation of a connection to some remote
+ * entity, like a socket or a pipe. It cannot be created directly,
+ * only acquired from a client socket.
+ */
+class LocalConnector : public FailableReference<LocalConnector>
+{
+public:
+    /**
+     * Connect to an address properly set up.
+     *
+     * If the connection succeeds immediately, it indicates success.
+     *
+     * If the connection does not succeed, because it would block, it
+     * sets up the socket to wait for the connection to succeed, and
+     * returns failure.
+     *
+     * If the connection fails for another reason, the error code is
+     * set, and false is returned.
+     */
+    bool connect();
+};
+
+//------------------------------------------------------------------------------
+
+} /* namespace xplcommon */
+
+//------------------------------------------------------------------------------
+
+#endif // 0, The public interface of a connector for a local client socket
+
+//------------------------------------------------------------------------------
+
+#include "config.h"
+
+//------------------------------------------------------------------------------
+
+#if TARGET_API_WIN32
+
+//------------------------------------------------------------------------------
+
+#include "win32/LocalConnector.h"
+
+namespace xplcommon { typedef win32::LocalConnector LocalConnector; }
+
+//------------------------------------------------------------------------------
+
+#else // TARGET_API_WIN32
+
+//------------------------------------------------------------------------------
+
+#include "posix/LocalConnector.h"
+
+namespace xplcommon { typedef posix::LocalConnector LocalConnector; }
+
+//------------------------------------------------------------------------------
+
+#endif // TARGET_API_WIN32
+
+//------------------------------------------------------------------------------
+#endif // XPLCOMMON_LOCALCONNECTOR_H
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/xplcommon/Makefile.am
===================================================================
--- src/xplcommon/Makefile.am	(revision 17)
+++ src/xplcommon/Makefile.am	(revision 21)
@@ -32,9 +32,7 @@
 	ReadingBuffer.h		\
 	WritingBuffer.h		\
-	Acceptor.h		\
 	LocalAcceptor.h		\
 	LocalSocket.h		\
 	LocalServerSocket.h	\
-	Connector.h		\
-	ClientSocket.h		\
+	LocalConnector.h	\
 	LocalClientSocket.h
Index: src/xplcommon/ReadingBuffer.h
===================================================================
--- src/xplcommon/ReadingBuffer.h	(revision 17)
+++ src/xplcommon/ReadingBuffer.h	(revision 21)
@@ -95,7 +95,7 @@
 //------------------------------------------------------------------------------
 
-// #include "win32/ReadingBuffer.h"
+#include "win32/ReadingBuffer.h"
 
-// namespace xplcommon { typedef win32::ReadingBuffer ReadingBuffer; }
+namespace xplcommon { typedef win32::ReadingBuffer ReadingBuffer; }
 
 //------------------------------------------------------------------------------
Index: src/xplcommon/WritingBuffer.h
===================================================================
--- src/xplcommon/WritingBuffer.h	(revision 17)
+++ src/xplcommon/WritingBuffer.h	(revision 21)
@@ -101,7 +101,7 @@
 //------------------------------------------------------------------------------
 
-// #include "win32/WritingBuffer.h"
+#include "win32/WritingBuffer.h"
 
-// namespace xplcommon { typedef win32::WritingBuffer WritingBuffer; }
+namespace xplcommon { typedef win32::WritingBuffer WritingBuffer; }
 
 //------------------------------------------------------------------------------
Index: src/xplcommon/posix/ClientSocket.cc
===================================================================
--- src/xplcommon/posix/ClientSocket.cc	(revision 16)
+++ src/xplcommon/posix/ClientSocket.cc	(revision 21)
@@ -41,22 +41,4 @@
 
 using xplcommon::posix::ClientSocket;
-using xplcommon::posix::Connector;
-
-//------------------------------------------------------------------------------
-
-ClientSocket::~ClientSocket()
-{
-    delete connector;
-}
-
-//------------------------------------------------------------------------------
-
-Connector& ClientSocket::getConnector()
-{
-    if (connector==0) {
-        connector = createConnector();
-    }
-    return *connector;
-}
 
 //------------------------------------------------------------------------------
@@ -64,6 +46,6 @@
 void ClientSocket::handleEvents(short events)
 {
-    if (connector!=0 && connector->connecting && (events&POLLOUT)==POLLOUT) {
-        connector->handleWritable();
+    if (connector.connecting && (events&POLLOUT)==POLLOUT) {
+        connector.handleWritable();
         events &= ~POLLOUT;
     }
Index: src/xplcommon/posix/ClientSocket.h
===================================================================
--- src/xplcommon/posix/ClientSocket.h	(revision 14)
+++ src/xplcommon/posix/ClientSocket.h	(revision 21)
@@ -51,7 +51,7 @@
 private:
     /**
-     * The connector, if any. It is created only, if requested.
+     * The connector.
      */
-    Connector* connector;
+    Connector& connector;
 
 protected:
@@ -59,25 +59,10 @@
      * Construct the socket with the given parameters.
      */
-    ClientSocket(int domain, int type, Waiter* waiter = 0, int protocol = 0,
+    ClientSocket(int domain, int type, Connector& connector,
+                 Waiter* waiter = 0, int protocol = 0,
                  size_t readingCapacity = DEFAULT_CAPACITY,
                  size_t writingCapacity = DEFAULT_CAPACITY);
 
-public:
-    /**
-     * Destroy the socket.
-     */
-    virtual ~ClientSocket();
-
-    /**
-     * Get the connector. Use this object to connect to another socket.
-     */
-    Connector& getConnector();
-
 protected:
-    /**
-     * Create a new connector of the correct type.
-     */
-    virtual Connector* createConnector() = 0;
-
     /**
      * Handle any events on the file descriptor. If a connection is in
@@ -105,9 +90,10 @@
 //------------------------------------------------------------------------------
 
-inline ClientSocket::ClientSocket(int domain, int type, Waiter* waiter,
-                                  int protocol, size_t readingCapacity,
+inline ClientSocket::ClientSocket(int domain, int type, Connector& connector,
+                                  Waiter* waiter, int protocol,
+                                  size_t readingCapacity,
                                   size_t writingCapacity) :
     Socket(domain, type, waiter, protocol, readingCapacity, writingCapacity),
-    connector(0)
+    connector(connector)
 {
 }
Index: src/xplcommon/posix/LocalClientSocket.cc
===================================================================
--- src/xplcommon/posix/LocalClientSocket.cc	(revision 15)
+++ src/xplcommon/posix/LocalClientSocket.cc	(revision 21)
@@ -32,5 +32,5 @@
 #include "LocalClientSocket.h"
 
-#include "Connector.h"
+#include "LocalConnector.h"
 #include "LocalServerSocket.h"
 
@@ -40,49 +40,4 @@
 
 using xplcommon::posix::LocalClientSocket;
-using xplcommon::posix::Connector;
-
-//------------------------------------------------------------------------------
-
-/**
- * The connector class used by the local client.
- */
-class LocalClientSocket::LocalConnector : public Connector
-{
-private:
-    /**
-     * The reference to the corresponding socket's address.
-     */
-    const struct sockaddr_un& address;
-
-public:
-    /**
-     * Create the connector for the given local client socket.
-     */
-    LocalConnector(LocalClientSocket* socket);
-
-protected:
-    /**
-     * Get the address.
-     */
-    virtual const struct sockaddr* getAddress(size_t& addrlen);
-};
-
-//------------------------------------------------------------------------------
-
-inline
-LocalClientSocket::LocalConnector::LocalConnector(LocalClientSocket* socket) :
-    Connector(socket),
-    address(socket->sun)
-{
-}
-
-//------------------------------------------------------------------------------
-
-const struct sockaddr*
-LocalClientSocket::LocalConnector::getAddress(size_t& addrlen)
-{
-    addrlen = sizeof(address);
-    return reinterpret_cast<const struct sockaddr*>(&address);
-}
 
 //------------------------------------------------------------------------------
@@ -92,16 +47,8 @@
                                      size_t readingCapacity,
                                      size_t writingCapacity) :
-    ClientSocket(AF_UNIX, SOCK_STREAM, waiter, 0,
-                 readingCapacity, writingCapacity)
+    ClientSocket(AF_UNIX, SOCK_STREAM, connector, waiter, 0,
+                 readingCapacity, writingCapacity),
+    connector(this, name)
 {
-    sun.sun_family = AF_UNIX;
-    LocalServerSocket::setupPath(sun, name);
-}
-
-//------------------------------------------------------------------------------
-
-Connector* LocalClientSocket::createConnector()
-{
-    return new LocalConnector(this);
 }
 
Index: src/xplcommon/posix/LocalClientSocket.h
===================================================================
--- src/xplcommon/posix/LocalClientSocket.h	(revision 15)
+++ src/xplcommon/posix/LocalClientSocket.h	(revision 21)
@@ -34,5 +34,5 @@
 #include "ClientSocket.h"
 
-#include <sys/un.h>
+#include "LocalConnector.h"
 
 //------------------------------------------------------------------------------
@@ -53,12 +53,7 @@
 private:
     /**
-     * The connector class.
-     */
-    class LocalConnector;
-
-    /**
      * The address to use for connecting.
      */
-    struct sockaddr_un sun;
+    LocalConnector connector;
 
 public:
@@ -76,12 +71,20 @@
                       size_t writingCapacity = DEFAULT_CAPACITY);
 
-protected:
     /**
-     * Create a new connector of the correct type.
+     * Get the connector for this client.
      */
-    virtual Connector* createConnector();
+    LocalConnector& getConnector();
 
     friend class LocalConnector;
 };
+
+//------------------------------------------------------------------------------
+// Inline definitions
+//------------------------------------------------------------------------------
+
+inline LocalConnector& LocalClientSocket::getConnector()
+{
+    return connector;
+}
 
 //------------------------------------------------------------------------------
Index: src/xplcommon/posix/LocalConnector.cc
===================================================================
--- src/xplcommon/posix/LocalConnector.cc	(revision 21)
+++ src/xplcommon/posix/LocalConnector.cc	(revision 21)
@@ -0,0 +1,52 @@
+// Copyright (c) 2012 by István Váradi
+
+// This file is part of libxplcommon, a common utility library for
+// development related to X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+//------------------------------------------------------------------------------
+
+#include "LocalConnector.h"
+
+//------------------------------------------------------------------------------
+
+using xplcommon::posix::LocalConnector;
+
+//------------------------------------------------------------------------------
+
+const struct sockaddr* LocalConnector::getAddress(size_t& addrlen)
+{
+    addrlen = sizeof(address);
+    return reinterpret_cast<const struct sockaddr*>(&address);
+}
+
+//------------------------------------------------------------------------------
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/xplcommon/posix/LocalConnector.h
===================================================================
--- src/xplcommon/posix/LocalConnector.h	(revision 21)
+++ src/xplcommon/posix/LocalConnector.h	(revision 21)
@@ -0,0 +1,90 @@
+// Copyright (c) 2012 by István Váradi
+
+// This file is part of libxplcommon, a common utility library for
+// development related to X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+#ifndef XPLCOMMON_POSIX_LOCALCONNECTOR_H
+#define XPLCOMMON_POSIX_LOCALCONNECTOR_H
+//------------------------------------------------------------------------------
+
+#include "Connector.h"
+
+#include "LocalServerSocket.h"
+
+#include <sys/socket.h>
+
+//------------------------------------------------------------------------------
+
+namespace xplcommon { namespace posix {
+
+//------------------------------------------------------------------------------
+
+/**
+ * The connector class used by the local client socket.
+ */
+class LocalConnector : public Connector
+{
+private:
+    /**
+     * The reference to the corresponding socket's address.
+     */
+    struct sockaddr_un address;
+
+public:
+    /**
+     * Create the connector for the given local client socket.
+     */
+    LocalConnector(ClientSocket* socket, const char* name);
+
+protected:
+    /**
+     * Get the address.
+     */
+    virtual const struct sockaddr* getAddress(size_t& addrlen);
+};
+
+//------------------------------------------------------------------------------
+
+inline LocalConnector::LocalConnector(ClientSocket* socket, const char* name) :
+    Connector(socket)
+{
+    address.sun_family = AF_UNIX;
+    LocalServerSocket::setupPath(address, name);
+}
+
+//------------------------------------------------------------------------------
+
+} /* namespace xplcommon::posix */ } /* namespace xplcommon */
+
+//------------------------------------------------------------------------------
+#endif // XPLCOMMON_POSIX_LOCALCONNECTOR_H
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/xplcommon/posix/Makefile.am
===================================================================
--- src/xplcommon/posix/Makefile.am	(revision 16)
+++ src/xplcommon/posix/Makefile.am	(revision 21)
@@ -15,4 +15,5 @@
 	ClientSocket.cc		\
 	LocalServerSocket.cc	\
+	LocalConnector.cc	\
 	LocalClientSocket.cc
 
@@ -35,3 +36,4 @@
 	LocalAcceptor.h		\
 	LocalServerSocket.h	\
+	LocalConnector.h	\
 	LocalClientSocket.h
Index: src/xplcommon/posix/ReadingBuffer.cc
===================================================================
--- src/xplcommon/posix/ReadingBuffer.cc	(revision 16)
+++ src/xplcommon/posix/ReadingBuffer.cc	(revision 21)
@@ -34,4 +34,6 @@
 #include "BufferedStream.h"
 
+#include <cassert>
+
 #include <poll.h>
 
@@ -60,5 +62,7 @@
     } else {
         stream.events &= ~POLLIN;
-        addLength(result);
+        size_t added = addLength(result);
+        assert(added==result);
+        assert(getLength()==result);
     }
     return result>=0;
Index: src/xplcommon/posix/Waitable.h
===================================================================
--- src/xplcommon/posix/Waitable.h	(revision 14)
+++ src/xplcommon/posix/Waitable.h	(revision 21)
@@ -93,10 +93,4 @@
 
     /**
-     * Indicate if this waitable is valid, i.e. the file descriptor is
-     * non-negative.
-     */
-    bool isValid() const;
-
-    /**
      * Determine if the waitable is ready or not, i.e. if there is no
      * need to wait for it.
@@ -143,11 +137,4 @@
 //------------------------------------------------------------------------------
 
-inline bool Waitable::isValid() const
-{
-    return fd>=0;
-}
-
-//------------------------------------------------------------------------------
-
 inline bool Waitable::ready()
 {
Index: src/xplcommon/win32/BufferedStream.cc
===================================================================
--- src/xplcommon/win32/BufferedStream.cc	(revision 21)
+++ src/xplcommon/win32/BufferedStream.cc	(revision 21)
@@ -0,0 +1,110 @@
+// Copyright (c) 2012 by István Váradi
+
+// This file is part of libxplcommon, a common utility library for
+// development related to X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+//------------------------------------------------------------------------------
+
+#include "BufferedStream.h"
+
+#include "ReadingBuffer.h"
+#include "WritingBuffer.h"
+
+//------------------------------------------------------------------------------
+
+using xplcommon::win32::BufferedStream;
+
+//------------------------------------------------------------------------------
+
+BufferedStream::BufferedStream(Waiter* waiter, HANDLE handle,
+                               size_t readingCapacity, size_t writingCapacity) :
+    Overlappable(waiter, handle),
+    readingBuffer( (readingCapacity==0) ? 0 :
+                   new ReadingBuffer(readingCapacity, this)),
+    writingBuffer( (writingCapacity==0) ? 0 :
+                   new WritingBuffer(writingCapacity, this))
+{
+}
+
+//------------------------------------------------------------------------------
+
+BufferedStream::~BufferedStream()
+{
+    delete writingBuffer;
+    delete readingBuffer;
+}
+
+//------------------------------------------------------------------------------
+
+ssize_t BufferedStream::read(void* dest, size_t length, Overlapped* overlapped)
+{
+    DWORD numRead = 0;
+    overlapped->reset();
+    bool result = ReadFile(handle, dest, length, 0, overlapped->get());
+                           // (overlapped==0) ? &numRead : 0,
+                           // (overlapped==0) ? 0 : overlapped->get());
+    DWORD error = GetLastError();
+    if (!result && (overlapped==0 ||
+                    (error!=ERROR_IO_PENDING && error!=ERROR_IO_INCOMPLETE)))
+    {
+        setErrorCode(error);
+        return -1;
+    } else if (overlapped==0 || overlapped->getResult(numRead, handle)) {
+        return numRead;
+    } else {
+        return -1;
+    }
+}
+
+//------------------------------------------------------------------------------
+
+bool BufferedStream::write(const void* src, size_t length,
+                           Overlapped* overlapped)
+{
+    bool result = WriteFile(handle, src, length, 0,
+                            (overlapped==0) ? 0 : overlapped->get());
+    DWORD error = GetLastError();
+    if (!result && (overlapped==0 ||
+                    (error!=ERROR_IO_PENDING && error!=ERROR_IO_INCOMPLETE)))
+    {
+        setErrorCode(error);
+        return false;
+    } else if (overlapped==0) {
+        return result;
+    } else {
+        DWORD numWritten = 0;
+        return overlapped->getResult(numWritten, handle);
+    }
+}
+
+//------------------------------------------------------------------------------
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
